--[[ Alt-Click to add an item to a mail for sending or to the trade frame. ]]--
AltClickToAddItem = AceLibrary("AceAddon-2.0"):new("AceHook-2.1")

function AltClickToAddItem:OnEnable()
 self:Hook("ContainerFrameItemButton_OnModifiedClick", true)
 self:HookScript(TradeFrame, "OnShow", "TFShow")
end

--Based on GMail 1.x which was ported from CT_MailMod pre-1.5
function AltClickToAddItem:ContainerFrameItemButton_OnModifiedClick(...)
  if  (...) == "LeftButton" and IsAltKeyDown() and not CursorHasItem() then
    self.bag, self.slot = this:GetParent():GetID(), this:GetID()
    if SendMailFrame:IsVisible() and not IsAddOnLoaded("Postal") and not IsAddOnLoaded("BulkMail2") then
      PickupContainerItem(self.bag, self.slot)
      ClickSendMailItemButton()
      return
    elseif TradeFrame:IsVisible() then
      for i = 1, 6 do
        if not GetTradePlayerItemLink(i) then
	  PickupContainerItem(self.bag, self.slot)
          ClickTradeButton(i)
	  return
        end
      end

    --Shamino added on behalf of Grennon.  Adds support for posting item into Auctioneer AuctionPost frame, when its available.
    elseif AuctionFrameTabPost and AuctionFrameTabPost:IsVisible() and IsAddOnLoaded("Auctioneer") then
	PickupContainerItem(self.bag, self.slot)
	AuctionFrameTabPost:Click()
	AuctionFramePost_AuctionItem_OnClick(AuctionFramePostAuctionItem);
	return

    elseif AuctionFrameAuctions and AuctionFrameAuctions:IsVisible() and not IsAddOnLoaded("Fence") then
      PickupContainerItem(self.bag, self.slot)
      ClickAuctionSellItemButton()
      return
    elseif not CursorHasItem() and UnitExists("target") and CheckInteractDistance("target", 2) 
      and UnitIsFriend("player", "target") and UnitIsPlayer("target")  then
      InitiateTrade("target")
      self.target = UnitName("target")
      return
    end
  end
  self.hooks["ContainerFrameItemButton_OnModifiedClick"](...)
end

function AltClickToAddItem:TFShow()
  self.hooks[TradeFrame].OnShow()
  if self.target and not CursorHasItem() and UnitName("target") == self.target then
    PickupContainerItem(self.bag, self.slot)
    ClickTradeButton(1)
  end
  self.target = nil
end
